package com.amap.app.cloud.activity;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.location.Location;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.provider.MediaStore;
import android.text.InputType;
import android.util.TypedValue;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.view.inputmethod.EditorInfo;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.EditText;
import android.widget.GridView;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.TextView;

import com.amap.api.location.AMapLocation;
import com.amap.api.location.AMapLocationListener;
import com.amap.api.location.LocationManagerProxy;
import com.amap.api.location.LocationProviderProxy;
import com.amap.api.maps.model.LatLng;
import com.amap.app.cloud.R;
import com.amap.app.cloud.adapter.GridViewAdapter_SelectedPic;
import com.amap.app.cloud.constants.CloudConstants;
import com.amap.app.cloud.dao.DataBaseAdapter;
import com.amap.app.cloud.net.Protocal;
import com.amap.app.cloud.pojo.CreateItemRequestEntity;
import com.amap.app.cloud.pojo.CreateItemResultEntity;
import com.amap.app.cloud.pojo.DatabaseItemEntity;
import com.amap.app.cloud.pojo.GeoEntity;
import com.amap.app.cloud.pojo.TableIdentifyStruct;
import com.amap.app.cloud.pojo.TableIdentifyStructReal;
import com.amap.app.cloud.pojo.TableIdentifyStructResult;
import com.amap.app.cloud.pojo.UploadPictureResultEntity;
import com.amap.app.cloud.util.ConfigableConst;
import com.amap.app.cloud.util.ImageUtil;
import com.amap.app.cloud.util.Util;
import com.lidroid.xutils.exception.HttpException;
import com.lidroid.xutils.http.ResponseInfo;
import com.lidroid.xutils.http.callback.RequestCallBack;

/**
 * @Project: YuntuConsoleAPP
 * @Class: AddDataInfoActivity
 * @Description: 向地图中添加信息
 * @date 2015年1月15日 下午5:22:32
 */
public class AddDataInfoActivity extends Activity implements OnClickListener,
		OnItemClickListener, AMapLocationListener {

	// 拍照
	private static final int REQUEST_CAMERA = 1;

	private static final int REQUEST_MAPLOCATION = 3;

	private LinearLayout llyBack = null;
	private LinearLayout llySave = null;
	private LinearLayout llyUploade = null;
	private LinearLayout llyInfoName = null;

	private LinearLayout llyPorps = null;
	private EditText etInfoName;
	private EditText etInfoAddr;
	private ImageView ivLocation;
	private View lineView = null;

	private View saveingView = null;
	private View parentView;
	// 自定义的弹出框类
	BottomPopupWindow menuWindow;

	private GridView gdSelectedPic;

	private GridViewAdapter_SelectedPic adapterSelected;

	private File cameraFile = null;

	private InputMethodManager imm;

	private LocationManagerProxy mLocationManagerProxy;

	private LatLng latlng;

	Protocal mProtocal = null;
	private List<TableIdentifyStruct> propsList = new ArrayList<TableIdentifyStruct>();
	private ArrayList<TableIdentifyStructReal> propsRealList = new ArrayList<TableIdentifyStructReal>();

	private Map<String, String> propsMap = new HashMap<String, String>();
	private ProgressDialog dialog;

	public Map<String, Bitmap> selectedPhotoMap = null;
	private CreateItemRequestEntity itemEntity;
	public static AddDataInfoActivity instance = null;

	// 编辑状态
	private boolean mEditState = false;
	private DatabaseItemEntity dataEntity = null;
	private String mAddressDes;

	private ProgressBar pbLocation;

	// 首次定位获取的地址
	private String firstLocationAddr;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		setContentView(R.layout.activity_adddatainfo);
		parentView = findViewById(R.id.addDataInfo);

		if (null == instance) {
			instance = this;
		}
		mProtocal = ConfigableConst.getProtocalInstance(this
				.getApplicationContext());
		selectedPhotoMap = new HashMap<String, Bitmap>();
		dealIntent();
		dialog = new ProgressDialog(this);
		dialog.setCancelable(false);
		dialog.setProgressStyle(ProgressDialog.STYLE_HORIZONTAL);

		imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
		initView();
		initEditData();
		llyBack.setOnClickListener(this);
		llySave.setOnClickListener(this);
		llyUploade.setOnClickListener(this);
		gdSelectedPic.setOnItemClickListener(this);
		ivLocation.setOnClickListener(this);

		adapterSelected
				.setOnViewClickListener(new GridViewAdapter_SelectedPic.OnViewClickListener() {

					@Override
					public void onImgClick(int position, String imgPath) {
						Bundle bundle = new Bundle();
						bundle.putInt(CloudConstants.PRRVIEPHOTO_TYPE_KEY,
								CloudConstants.PRRVIEPHOTO_TYPE_LOCAL);
						bundle.putInt("pageIndex", position);
						Intent intent = new Intent(AddDataInfoActivity.this,
								PreviewPhotoActivity.class);
						intent.putExtras(bundle);
						startActivity(intent);
					}

					@Override
					public void onDelBtClick(int position, String imgPath) {
						selectedPhotoMap.remove(imgPath);
						updateAdapter();
					}
				});

		// 执行一次定位
		doLocation();
	}

	private void dealIntent() {
		Intent intent = getIntent();
		if (intent == null) {
			return;
		}
		mEditState = intent.getBooleanExtra(ConfigableConst.EDITE_BOOLEAN,
				false);
		long dataid = intent.getLongExtra(ConfigableConst.DATA_ID, -1);
		if (dataid > 0) {
			try {
				DataBaseAdapter database = new DataBaseAdapter(this);
				database.open();
				dataEntity = database.fetchData(dataid);
				database.close();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		getTableStruct(ConfigableConst.tableID);
		if (dataEntity == null) {
			return;
		}
		ArrayList<byte[]> photoList = dataEntity.getPhotoList();
		if (photoList != null) {
			for (int i = 0; i < photoList.size(); i++) {
				byte[] photo = photoList.get(i);
				Bitmap bit = Util.bytes2Bimap(photo);
				selectedPhotoMap.put(String.valueOf(i), bit);
			}
		}
	}

	public void initView() {
		llyBack = (LinearLayout) findViewById(R.id.title_lly_back);
		llySave = (LinearLayout) findViewById(R.id.title_lly_save);
		llyUploade = (LinearLayout) findViewById(R.id.title_lly_upload);
		llyInfoName = (LinearLayout) findViewById(R.id.lly_infoName);
		llyPorps = (LinearLayout) findViewById(R.id.lly_props);
		etInfoAddr = (EditText) findViewById(R.id.et_infoAddr);
		etInfoName = (EditText) findViewById(R.id.et_infoName);
		ivLocation = (ImageView) findViewById(R.id.iv_location);
		lineView = findViewById(R.id.lineView);

		saveingView = findViewById(R.id.rly_saveing);

		pbLocation = (ProgressBar) findViewById(R.id.pb_location);
		pbLocation.setVisibility(View.GONE);

		gdSelectedPic = (GridView) findViewById(R.id.gd_selectedPic);
		adapterSelected = new GridViewAdapter_SelectedPic(this,
				selectedPhotoMap);
		gdSelectedPic.setAdapter(adapterSelected);
	}

	private void initEditData() {
		if (!mEditState || dataEntity == null) {
			return;
		}
		etInfoAddr.setText(dataEntity.getAddress());
		etInfoName.setText(dataEntity.getName());
	}

	/**
	 * 
	 */
	public void updateAdapter() {
		adapterSelected.setItemMap(selectedPhotoMap);
		gdSelectedPic.setAdapter(adapterSelected);
	}

	/**
	 * 创建自定义 字段
	 * 
	 * @param i
	 * @return
	 */
	private LinearLayout createCustomProp(TableIdentifyStruct struct,
			int imeOptions) {

		LinearLayout lly = new LinearLayout(this);
		lly.setOrientation(LinearLayout.HORIZONTAL);

		lly.setLayoutParams(llyInfoName.getLayoutParams());
		lly.setGravity(Gravity.CENTER_VERTICAL);
		TextView tv = new TextView(this);
		tv.setTextSize(
				TypedValue.COMPLEX_UNIT_PX,
				getResources().getDimension(
						R.dimen.textsize_list_item_titleText));
		tv.setTextColor(getResources().getColor(
				R.color.textColor_list_item_titleText));
		if (null == struct.getName() || struct.getName().trim().length() <= 0) {
			tv.setText(struct.getKey());
		} else {
			tv.setText(struct.getName());
		}
		EditText et = new EditText(this);
		et.setBackgroundResource(R.drawable.custom_background_edittext_noframe);
		et.setLayoutParams(etInfoName.getLayoutParams());
		et.setTextSize(TypedValue.COMPLEX_UNIT_PX,
				getResources()
						.getDimension(R.dimen.textsize_list_item_descText));
		et.setTextColor(getResources().getColor(
				R.color.textColor_list_item_descText));
		if (struct.getType().equalsIgnoreCase("Integer")) {
			et.setInputType(InputType.TYPE_CLASS_NUMBER);
		} else if (struct.getType().equalsIgnoreCase("Numeric")) {
			et.setRawInputType(InputType.TYPE_CLASS_NUMBER
					| InputType.TYPE_NUMBER_FLAG_DECIMAL);
		}

		String value = getJSONString(struct);
		et.setText(value);

		et.setImeOptions(imeOptions);
		lly.addView(tv);
		lly.addView(et);
		TableIdentifyStructReal real = new TableIdentifyStructReal();
		real.setTextView(tv);
		real.setEditText(et);
		real.setKey(struct.getKey());
		real.setName(struct.getName());
		real.setType(struct.getType());
		propsRealList.add(real);
		return lly;
	}

	private String getJSONString(TableIdentifyStruct struct) {
		String result = "";
		if (dataEntity == null) {
			return result;
		}
		JSONObject object = dataEntity.getProps();
		if (object == null) {
			return result;
		}
		String key = struct.getKey();
		if (object.has(key)) {
			result = object.optString(key);
		}
		return result;
	}

	private int getJSONint(TableIdentifyStruct struct) {
		int result = 0;
		if (dataEntity == null) {
			return result;
		}
		JSONObject object = dataEntity.getProps();
		if (object == null) {
			return result;
		}
		String key = struct.getKey();
		if (object.has(key)) {
			result = object.optInt(key);
		}
		return result;
	}

	private double getJSONfloat(TableIdentifyStruct struct) {
		double result = 0;
		if (dataEntity == null) {
			return result;
		}
		JSONObject object = dataEntity.getProps();
		if (object == null) {
			return result;
		}
		String key = struct.getKey();
		if (object.has(key)) {
			result = object.optDouble(key);
		}
		return result;
	}

	/**
	 * 判断是否已经填写数据，目前仅判断名称、地址、照片
	 * 
	 * @return
	 */
	private boolean isHasData() {
		if (mEditState) {
			return false;
		}
		String strName = "";
		String strAddr = "";
		if (null != etInfoName) {
			strName = etInfoName.getText().toString().trim();
		}

		if (null != etInfoAddr) {
			strAddr = etInfoAddr.getText().toString().trim();
		}

		if (strName.length() > 0
				|| (strAddr.length() > 0
						&& !strAddr.equals(getResources().getString(
								R.string.locationErr))
						&& !strAddr.equals(getResources().getString(
								R.string.locationing)) && !strAddr
							.equals(firstLocationAddr))
				|| (null != selectedPhotoMap && selectedPhotoMap.size() > 0)) {
			return true;
		} else {
			return false;
		}
	}

	/**
	 * 返回提示，防止为保存误点退出
	 */
	private void alertBack() {
		AlertDialog.Builder builder = new Builder(this);
		builder.setTitle("数据提示");
		builder.setMessage(getResources()
				.getString(R.string.confirmOutEditData));
		builder.setCancelable(false);
		builder.setPositiveButton(R.string.backOutEditData,
				new android.content.DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which) {
						AddDataInfoActivity.this.finish();
					}
				});
		builder.setNegativeButton(R.string.continueEditData,
				new android.content.DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which) {
						dialog.dismiss();
					}
				});
		builder.create().show();
	}

	@Override
	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.title_lly_back:
			if (isHasData()) {
				alertBack();
			} else {
				this.finish();
			}
			break;
		case R.id.title_lly_save:
			if (!isValid()) {
				break;
			}
			saveThread.start();
			break;
		case R.id.title_lly_upload:
			if (!isValid()) {
				break;
			}
			checkBeforeUpload();
			break;
		case R.id.iv_location:
			showMenuWindow(CloudConstants.OPTION_POPWIN_LOCATION);
			break;
		}
	}

	/**
	 * 显示无网络连接对话框
	 */
	private void showNetworkDialog() {
		AlertDialog.Builder builder = new Builder(this);
		builder.setTitle("网络提示");
		builder.setMessage(getResources().getString(R.string.noNetwork));
		builder.setCancelable(false);
		builder.setPositiveButton(R.string.confirm, null);
		builder.create().show();
	}

	private void showWifiDialog() {
		AlertDialog.Builder alert = new AlertDialog.Builder(this);
		alert.setTitle("网络提示");
		alert.setMessage(getResources().getString(R.string.notInWifi));
		alert.setCancelable(false);
		alert.setPositiveButton("仍然上传", new DialogInterface.OnClickListener() {
			@Override
			public void onClick(DialogInterface dialog, int which) {
				upload();
			}
		});
		alert.setNegativeButton("取消", new DialogInterface.OnClickListener() {
			@Override
			public void onClick(DialogInterface dialog, int which) {
				dialog.dismiss();
			}
		});
		alert.show();
	}

	/**
	 * 上传前的检测
	 */
	private void checkBeforeUpload() {
		if (!Util.isNetworkConnected(this)) {
			showNetworkDialog();
			return;
		}
		upload();
	}

	private void upload() {
		dialog.setTitle(getResources().getString(R.string.uploading));
		dialog.setMessage(getResources().getString(R.string.uploadingData));
		dialog.setIndeterminate(true);
		dialog.show();
		itemEntity = getItemEntity();
		mProtocal.createItem(ConfigableConst.tableID, ConfigableConst.sid,
				itemEntity, callBack);
	}

	/**
	 * 是否有效
	 * 
	 * @return true:有效
	 */
	private boolean isValid() {
		if ("".equals(etInfoName.getText().toString().trim())) {
			Util.showToast(getApplicationContext(),
					getResources().getString(R.string.nameNotAllowEmpty));
			etInfoName
					.setBackgroundResource(R.drawable.custom_background_edittext_noframe_err);
			etInfoName.requestFocus();
			return false;
		}
		etInfoName
				.setBackgroundResource(R.drawable.custom_background_edittext_noframe);
		if ("".equals(etInfoAddr.getText().toString().trim())
				|| etInfoAddr.getText().toString().trim()
						.equals(getResources().getString(R.string.locationErr))) {
			Util.showToast(getApplicationContext(),
					getResources().getString(R.string.addrNotAllowEmpty));
			etInfoAddr
					.setBackgroundResource(R.drawable.custom_background_edittext_noframe_err);
			etInfoAddr.requestFocus();
			return false;
		}
		etInfoAddr
				.setBackgroundResource(R.drawable.custom_background_edittext_noframe);

		for (TableIdentifyStructReal identify : propsRealList) {
			String name = identify.getName();
			String type = identify.getType();

			if (null == name || name.trim().length() <= 0) {
				name = identify.getKey();
			}

			EditText ev = identify.getEditText();
			if (ev == null || ev.getText() == null
					|| ev.getText().toString().equals("")) {
				continue;
			}
			String value = ev.getText().toString();
			if (value.length() > ConfigableConst.MAXPROPLEN) {
				ev.setBackgroundResource(R.drawable.custom_background_edittext_noframe_err);
				Util.showToast(getApplicationContext(), name + "的内容过 长,请修正");
				ev.requestFocus();
				return false;
			}

			if (type.equalsIgnoreCase("Integer")) {
				if (!Util.isValidNumber(value.trim())) {
					ev.setBackgroundResource(R.drawable.custom_background_edittext_noframe_err);
					Util.showToast(getApplicationContext(), name
							+ getResources().getString(R.string.invalidNumber));
					ev.requestFocus();
					return false;
				}
			} else if (type.equalsIgnoreCase("Numeric")) {
				if (!Util.isValidDecimal(value.trim())) {
					ev.setBackgroundResource(R.drawable.custom_background_edittext_noframe_err);
					Util.showToast(getApplicationContext(), name
							+ getResources().getString(R.string.invalidDecimal));
					ev.requestFocus();
					return false;
				}
			}
			ev.setBackgroundResource(R.drawable.custom_background_edittext_noframe);
		}

		return true;
	}

	RequestCallBack<String> callBack = new RequestCallBack<String>() {

		@Override
		public void onSuccess(ResponseInfo<String> responseInfo) {
			CreateItemResultEntity resultEntity = mProtocal.parseResult(
					responseInfo, CreateItemResultEntity.class);
			if (resultEntity == null) {
				Util.showToast(getApplicationContext(), "上传失败");
				return;
			}
			switch (resultEntity.getRc()) {
			case 1:
				ArrayList<byte[]> byteList = getBytePhotoList();
				if (byteList == null || byteList.size() == 0) {
					dialog.dismiss();
					Util.showToast(getApplicationContext(), "上传成功");
					if (dataEntity != null && mEditState) {
						deleteData(dataEntity.getId());
						ArrayList<Activity> list = ConfigableConst.cacheActivity;
						for (Activity act : list) {
							act.finish();
						}
					}
					refreshMapTableData(false);
					AddDataInfoActivity.this.finish();
				} else {
					if (!dialog.isShowing()) {
						dialog.show();
					}
					dialog.setMessage(getResources().getString(
							R.string.uploadingImg));
					dialog.setIndeterminate(false);
					dialog.setMax(100);
					String dataID = resultEntity.getId();
					mProtocal.uploadImage(ConfigableConst.tableID,
							ConfigableConst.sid, dataID, null,
							getBytePhotoList(), callBackPhoto);
				}
				break;
			case 0:
				dialog.dismiss();
				Util.showToast(getApplicationContext(), "上传失败，未知原因");
				break;
			case -1:
				dialog.dismiss();
				Util.showToast(getApplicationContext(), "上传失败，tableId不存在");
				break;
			case -11:
				dialog.dismiss();
				Util.showToast(getApplicationContext(), "上传失败，数据类型非法");
				break;
			case -12:
				dialog.dismiss();
				Util.showToast(getApplicationContext(), "上传失败，数据长度超限");
				break;
			case -13:
				dialog.dismiss();
				Util.showToast(getApplicationContext(), "上传失败，包含敏感词");
				break;
			case -21:
				dialog.dismiss();
				Util.showToast(getApplicationContext(), "上传失败，用量达到上限");
				break;
			default:
				dialog.dismiss();
				break;

			}
		}

		@Override
		public void onFailure(HttpException error, String msg) {
			dialog.dismiss();
			Util.showToast(getApplicationContext(), ConfigableConst.NET_ERROR);
		}
	};

	RequestCallBack<String> callBackPhoto = new RequestCallBack<String>() {

		@Override
		public void onLoading(long total, long current, boolean isUploading) {
			if (isUploading) {
				int progress = (int) (((current * 1.0f) / total) * 100);
				dialog.setProgress(progress);
			}
		}

		@Override
		public void onSuccess(ResponseInfo<String> responseInfo) {
			dialog.dismiss();
			String[] resJSONArray = responseInfo.result.split("\\}");
			for (int i = 0; i < resJSONArray.length; i++) {
				resJSONArray[i] = resJSONArray[i] + "}";
			}
			int failureCount = 0;
			for (int i = 0; i < resJSONArray.length; i++) {
				UploadPictureResultEntity picEntity = mProtocal.parseResult(
						resJSONArray[i], UploadPictureResultEntity.class);
				if (picEntity == null) {
					continue;
				}
				if (picEntity.getRc() != 1) {
					failureCount++;
				}
				switch (picEntity.getRc()) {
				case 1:
					break;
				case 0:
					Util.showToast(getApplicationContext(), "上传图片失败");
					break;
				case -1:
					Util.showToast(getApplicationContext(), "上传图片失败，tableId不存在");
					break;
				case -2:
					Util.showToast(getApplicationContext(), "上传图片失败，dataId不存在");
					break;
				case -11:
					Util.showToast(getApplicationContext(), "上传图片失败，图片格式错误");
					break;
				case -12:
					Util.showToast(getApplicationContext(), "上传图片失败，图片体积超限");
					break;
				case -21:
					Util.showToast(getApplicationContext(), "上传图片失败，图用量达到上限");
					break;
				default:
					break;
				}
			}

			if (failureCount > 0) {
				Util.showToast(getApplicationContext(), "成功上传" + failureCount
						+ "张照片");
			} else {
				Util.showToast(getApplicationContext(), "成功上传");
			}
			dialog.cancel();
			if (dataEntity != null && mEditState) {
				deleteData(dataEntity.getId());
				ArrayList<Activity> list = ConfigableConst.cacheActivity;
				for (Activity act : list) {
					act.finish();
				}
			}
			refreshMapTableData(false);
			AddDataInfoActivity.this.finish();
		}

		@Override
		public void onFailure(HttpException error, String msg) {
			dialog.dismiss();
			dialog.cancel();
			Util.showToast(getApplicationContext(), ConfigableConst.NET_ERROR);
			if (dataEntity != null && mEditState) {
				deleteData(dataEntity.getId());
				ArrayList<Activity> list = ConfigableConst.cacheActivity;
				for (Activity act : list) {
					act.finish();
				}
			}
			refreshMapTableData(false);
			AddDataInfoActivity.this.finish();
		}
	};

	private boolean deleteData(long rowid) {
		if (dataEntity == null) {
			return false;
		}
		DataBaseAdapter dataAdapter = new DataBaseAdapter(this);
		dataAdapter.open();
		boolean dataresult = dataAdapter.deleteTableData(rowid);
		boolean photoresult = dataAdapter.deletePhotoData(rowid);
		return dataresult && photoresult;
	}

	Handler saveHandler = new Handler() {

		@Override
		public void handleMessage(Message msg) {
			switch (msg.what) {
			// 正在进行
			case 0:
				saveingView.setVisibility(View.VISIBLE);
				break;
			// 保存成功
			case 1:
				saveingView.setVisibility(View.GONE);
				Util.showToast(getApplicationContext(), getResources()
						.getString(R.string.saveDataSuccess));
				refreshMapTableData(true);
				AddDataInfoActivity.this.finish();
				break;
			// 保存失败
			case -1:
				Util.showToast(getApplicationContext(), getResources()
						.getString(R.string.saveDataFail));
				saveingView.setVisibility(View.GONE);
				break;
			}
		}

	};

	private Thread saveThread = new Thread() {

		@Override
		public void run() {
			saveHandler.sendEmptyMessage(0);
			boolean result = false;
			DatabaseItemEntity itemDatabase = getItemEntity();
			DataBaseAdapter adapter = new DataBaseAdapter(
					AddDataInfoActivity.this);
			adapter.open();
			if (mEditState) {
				if (dataEntity == null) {
					result = false;
				}
				long rowid = dataEntity.getId();
				result = adapter.updateTableData(rowid, itemDatabase);
				ArrayList<byte[]> list = getBytePhotoList();
				if (list != null) {
					adapter.updatePhotoData(rowid, list);
				}
			} else {
				long id = adapter.insertData(itemDatabase, getBytePhotoList());
				if (id != -1) {
					result = true;
				}
			}
			adapter.close();
			if (result) {
				saveHandler.sendEmptyMessage(1);
			} else {
				saveHandler.sendEmptyMessage(-1);
			}
		}

	};

	private DatabaseItemEntity getItemEntity() {
		DatabaseItemEntity itemDatabase = new DatabaseItemEntity();
		itemDatabase.setTableID(ConfigableConst.tableID);
		itemDatabase.setName(etInfoName.getText().toString());
		itemDatabase.setAddress(etInfoAddr.getText().toString());
		itemDatabase.setPosType(2);
		itemDatabase.setCoordType(2);
		itemDatabase.setProps(getPropsJSONObjet());
		itemDatabase.setPhotoList(getBytePhotoList());
		itemDatabase.setGeo(getGeoEntity());
		return itemDatabase;
	}

	private GeoEntity getGeoEntity() {
		GeoEntity entity = null;
		if (etInfoAddr.getText().toString().equalsIgnoreCase(mAddressDes)
				&& latlng != null) {
			entity = new GeoEntity();
			ArrayList<Float> list = new ArrayList<Float>();
			list.add((float) latlng.longitude);
			list.add((float) latlng.latitude);
			entity.setCoords(list);
			entity.setType("Point");
		}
		return entity;
	}

	private ArrayList<byte[]> getBytePhotoList() {
		ArrayList<byte[]> byteList = new ArrayList<byte[]>();
		Iterator<Entry<String, Bitmap>> iterator = selectedPhotoMap.entrySet()
				.iterator();
		while (iterator.hasNext()) {
			Entry<String, Bitmap> entry = iterator.next();
			byte[] bit = Util.getBitmapByte(entry.getValue());
			if (bit == null || bit.length == 0) {
				continue;
			}
			byteList.add(bit);
		}
		return byteList;
	}

	private JSONObject getPropsJSONObjet() {
		JSONObject json = new JSONObject();
		try {
			for (TableIdentifyStructReal identify : propsRealList) {
				String name = identify.getKey();
				EditText ev = identify.getEditText();
				if (ev == null || ev.getText() == null
						|| ev.getText().toString().equals("")) {
					continue;
				}
				String value = ev.getText().toString().trim();
				json.put(name, value);
			}
		} catch (JSONException e) {
			e.printStackTrace();
		}
		return json;
	}

	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		switch (requestCode) {
		case REQUEST_CAMERA:
			if (resultCode == RESULT_OK) {
				if (null != cameraFile) {
					Bitmap bitmap = ImageUtil.revisionImageSize(
							cameraFile.getPath(), CloudConstants.MAXPHOTOPIXEL);
					if (null != bitmap) {
						selectedPhotoMap.put(cameraFile.getPath(), bitmap);
					}
					if (cameraFile.exists()) {
						cameraFile.delete();
					}
					updateAdapter();
				}
			}
			break;
		case REQUEST_MAPLOCATION:
			if (resultCode == RESULT_OK) {
				mAddressDes = data.getStringExtra("addr");
				etInfoAddr.setText(mAddressDes);
				firstLocationAddr = mAddressDes;
			}
		}
	}

	/**
	 * 拍照取照片
	 */
	private void doTakePhoto() {
		String fileName = String.valueOf(System.currentTimeMillis()) + ".jpg";
		cameraFile = new File(getExternalCacheDir(), fileName);
		Intent intent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
		intent.putExtra(MediaStore.EXTRA_OUTPUT, Uri.fromFile(cameraFile));
		startActivityForResult(intent, REQUEST_CAMERA);
	}

	/**
	 * 相册去照片
	 */
	private void doPickPhoto() {
		Intent intent = new Intent(this, PhotoListActivity.class);
		startActivity(intent);
	}

	// 为图片选择弹出窗口实现监听类
	private OnClickListener picItemsOnClick = new OnClickListener() {
		public void onClick(View v) {
			menuWindow.dismiss();
			switch (v.getId()) {
			case R.id.popwin_btn1:
				doTakePhoto();
				break;
			case R.id.popwin_btn2:
				doPickPhoto();
				break;
			default:
				break;
			}
		}
	};

	/**
	 * 进行一次定位
	 */
	private void doLocation() {
		if (mEditState) {
			return;
		}
		pbLocation.setVisibility(View.VISIBLE);
		etInfoAddr.setText(getResources().getString(R.string.locationing));

		mLocationManagerProxy = LocationManagerProxy.getInstance(this);
		LocationManagerProxy.getInstance(this).requestLocationData(
				LocationProviderProxy.AMapNetwork, -1, 15, this);
	}

	/**
	 * 地图选点
	 */
	private void doMapLocation() {
		Intent intent = new Intent(AddDataInfoActivity.this,
				MapLocationActivity.class);
		startActivityForResult(intent, REQUEST_MAPLOCATION);
	}

	// 为位置选择窗口实现监听类
	private OnClickListener locationItemsOnClick = new OnClickListener() {
		public void onClick(View v) {
			menuWindow.dismiss();
			switch (v.getId()) {
			case R.id.popwin_btn1:
				doLocation();
				break;
			case R.id.popwin_btn2:
				doMapLocation();
				break;
			default:
				break;
			}
		}
	};

	private void showMenuWindow(int optionType) {
		hideSoftKey();
		// 实例化SelectPicPopupWindow
		if (optionType == CloudConstants.OPTION_POPWIN_PIC) {
			menuWindow = new BottomPopupWindow(AddDataInfoActivity.this,
					optionType, picItemsOnClick);
		} else if (optionType == CloudConstants.OPTION_POPWIN_LOCATION) {
			menuWindow = new BottomPopupWindow(AddDataInfoActivity.this,
					optionType, locationItemsOnClick);
		}
		// 显示窗口
		menuWindow.showAtLocation(parentView, Gravity.BOTTOM
				| Gravity.CENTER_HORIZONTAL, 0, 0);
	}

	// 隐藏键盘
	private void hideSoftKey() {
		if (imm.isActive()) {
			imm.hideSoftInputFromWindow(parentView.getWindowToken(),
					InputMethodManager.HIDE_NOT_ALWAYS);
		}
	}

	@Override
	public void onItemClick(AdapterView<?> parent, View view, int position,
			long id) {
		if (parent.getId() == R.id.gd_selectedPic) {
			if (selectedPhotoMap.size() == 0) {
				showMenuWindow(CloudConstants.OPTION_POPWIN_PIC);
			} else {
				if (position == selectedPhotoMap.size()
						&& selectedPhotoMap.size() < CloudConstants.MAXPICNUM) {
					showMenuWindow(CloudConstants.OPTION_POPWIN_PIC);
				}
			}
		}
	}

	@Override
	public void onLocationChanged(Location location) {
		// TODO 自动生成的方法存根

	}

	@Override
	public void onStatusChanged(String provider, int status, Bundle extras) {
		// TODO 自动生成的方法存根

	}

	@Override
	public void onProviderEnabled(String provider) {
		// TODO 自动生成的方法存根

	}

	@Override
	public void onProviderDisabled(String provider) {
		// TODO 自动生成的方法存根

	}

	@Override
	public void onLocationChanged(AMapLocation amapLocation) {
		pbLocation.setVisibility(View.GONE);
		if (amapLocation != null
				&& amapLocation.getAMapException().getErrorCode() == 0) {
			mAddressDes = amapLocation.getAddress();
			etInfoAddr.setTextColor(getResources().getColor(
					R.color.textColor_list_item_descText));
			etInfoAddr.setText(mAddressDes);
			firstLocationAddr = mAddressDes;
			latlng = new LatLng(amapLocation.getLatitude(),
					amapLocation.getLongitude());
		} else {
			etInfoAddr.setTextColor(getResources().getColor(R.color.red));
			etInfoAddr.setText(getResources().getString(R.string.locationErr));
		}
	}

	@Override
	protected void onPause() {
		super.onPause();
		// 移除定位请求
		if (mLocationManagerProxy != null) {
			mLocationManagerProxy.removeUpdates(this);
			// 销毁定位
			mLocationManagerProxy.destroy();
		}
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
		instance = null;
	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if (keyCode == KeyEvent.KEYCODE_BACK) {
			if (isHasData()) {
				alertBack();
			} else {
				this.finish();
			}
		}
		return super.onKeyDown(keyCode, event);
	}

	/**
	 * 刷新数据列表
	 * 
	 * @param isLocalDataList
	 *            是否切换到未上传列表界面
	 */
	private void refreshMapTableData(boolean isLocalDataList) {
		if (null != MapTableDataActivity.instance) {
			MapTableDataActivity.instance.isLocalDataList = isLocalDataList;
			MapTableDataActivity.instance.onRefresh();
			MapTableDataActivity.instance.refreshMapTableList();
		}
	}

	private void getTableStruct(String tableId) {
		mProtocal.fetchTableStruct(tableId, ConfigableConst.sid,
				requestCallBack);
	}

	private RequestCallBack<String> requestCallBack = new RequestCallBack<String>() {
		@Override
		public void onSuccess(ResponseInfo<String> responseInfo) {
			TableIdentifyStructResult result = mProtocal.parseResult(
					responseInfo, TableIdentifyStructResult.class);
			if (result == null) {
				return;
			}
			int rc = result.getRc();

			if (rc != 1) {
				switch (rc) {
				case 0:
					Util.showToast(getApplicationContext(), "获取数据失败");
					break;
				case -1:
					Util.showToast(getApplicationContext(), "tableID不存在");
					break;
				default:
					Util.showToast(getApplicationContext(), "获取数据失败");
					break;
				}
				return;
			}
			propsList = result.getList();
			if (propsList.size() > 0) {
				View mLineView = new View(AddDataInfoActivity.this);
				mLineView.setLayoutParams(lineView.getLayoutParams());
				mLineView.setBackgroundColor(getResources().getColor(
						R.color.backgroud_list_item_line));
				llyPorps.addView(mLineView);
			}
			// 将结构存入map中
			propsRealList.clear();
			for (int i = 0; i < propsList.size(); i++) {
				TableIdentifyStruct struct = propsList.get(i);
				int imeOptions = EditorInfo.IME_ACTION_NEXT;
				if (i == propsList.size() - 1) {
					imeOptions = EditorInfo.IME_ACTION_DONE;
				}
				llyPorps.addView(createCustomProp(struct, imeOptions));
				if (i < propsList.size() - 1) {
					View mLineView = new View(AddDataInfoActivity.this);
					mLineView.setLayoutParams(lineView.getLayoutParams());
					mLineView.setBackgroundColor(getResources().getColor(
							R.color.backgroud_list_item_line));
					llyPorps.addView(mLineView);
				}
			}
		}

		@Override
		public void onFailure(HttpException error, String msg) {
			Util.showToast(getApplicationContext(), ConfigableConst.NET_ERROR);
		}
	};

}
