/**
 */
package com.amap.app.cloud.activity;

import java.lang.ref.SoftReference;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.support.v4.view.PagerAdapter;
import android.support.v4.view.ViewPager;
import android.support.v4.view.ViewPager.OnPageChangeListener;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup.LayoutParams;
import android.view.Window;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ImageView.ScaleType;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.amap.app.cloud.R;
import com.amap.app.cloud.constants.CloudConstants;
import com.amap.app.cloud.net.Protocal;
import com.amap.app.cloud.pojo.ImageEntity;
import com.amap.app.cloud.util.ConfigableConst;
import com.amap.app.cloud.util.Util;
import com.lidroid.xutils.bitmap.BitmapDisplayConfig;
import com.lidroid.xutils.bitmap.callback.BitmapLoadCallBack;
import com.lidroid.xutils.bitmap.callback.BitmapLoadFrom;

/**
 * @Description: 预览照片activity
 * @Project: YuntuConsoleAPP
 * @Class: PreviewPhotoActivity
 * @date 2015年1月31日 下午2:18:46
 */
public class PreviewPhotoActivity extends Activity implements OnClickListener {
	private ArrayList<View> listViews = null;
	private List<String> lstKeys = new ArrayList<String>();
	private ViewPager phtoPager;
	private MyPageAdapter adapter;
	private int pageIndex = 0;
	private int pageCount = 0;

	private LinearLayout llyBack;
	private TextView tvPage;
	private RelativeLayout optionLayout;
	private Button btDel;
	private Button btOK;
	private Protocal protocal;
	private int type = 0;

	private ProgressBar pbLoding;

	private HashMap<Integer, SoftReference<Bitmap>> loadImageCache = new HashMap<Integer, SoftReference<Bitmap>>();

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		setContentView(R.layout.activity_preview_photo);

		llyBack = (LinearLayout) findViewById(R.id.title_lly_back);
		tvPage = (TextView) findViewById(R.id.title_tv_page);
		optionLayout = (RelativeLayout) findViewById(R.id.rly_option);
		pbLoding = (ProgressBar) findViewById(R.id.pb_loading);
		btDel = (Button) findViewById(R.id.bt_photo_del);
		btOK = (Button) findViewById(R.id.bt_photo_ok);

		llyBack.setOnClickListener(this);
		btDel.setOnClickListener(this);
		btOK.setOnClickListener(this);
		protocal = new Protocal(this);
		phtoPager = (ViewPager) findViewById(R.id.viewpager_photo);
		phtoPager.setOnPageChangeListener(pageChangeListener);
		Intent intent = getIntent();
		Bundle bundle = intent.getExtras();

		if (null != bundle) {
			type = bundle.getInt(CloudConstants.PRRVIEPHOTO_TYPE_KEY, 0);
			pageIndex = intent.getIntExtra("pageIndex", 0);
			if (type == CloudConstants.PRRVIEPHOTO_TYPE_SERVER) {
				optionLayout.setVisibility(View.GONE);
				if (ConfigableConst.imageEntityList == null) {
					return;
				} else {
					pageCount = ConfigableConst.imageEntityList.size();
					for (int i = 0; i < pageCount; i++) {
						ImageEntity imageEntity = ConfigableConst.imageEntityList
								.get(i);
						if (imageEntity != null) {
							initListViews(imageEntity.getUrl());
						}
					}
				}
			}
			if (type == CloudConstants.PRRVIEPHOTO_TYPE_LOCAL) {
				if (null != ConfigableConst.bitmapByteList) {
					pageCount = ConfigableConst.bitmapByteList.size();
					for (int i = 0; i < pageCount; i++) {
						byte[] byteim = ConfigableConst.bitmapByteList.get(i);
						initListViews(Util.bytes2Bimap(byteim));
					}
				}

				if (null != AddDataInfoActivity.instance) {
					Map<String, Bitmap> dataMap = AddDataInfoActivity.instance.selectedPhotoMap;
					Iterator<Entry<String, Bitmap>> iterator = dataMap
							.entrySet().iterator();
					pageCount = dataMap.size();
					while (iterator.hasNext()) {
						Entry<String, Bitmap> entry = iterator.next();
						lstKeys.add(entry.getKey());
						initListViews(entry.getValue());
					}
					if (pageCount > 0) {
						optionLayout.setVisibility(View.VISIBLE);
					}
				}
			}
		}

		adapter = new MyPageAdapter(listViews);// 构造adapter
		phtoPager.setAdapter(adapter);// 设置适配器
		phtoPager.setCurrentItem(pageIndex);
		if (pageCount > 0) {
			tvPage.setText((pageIndex + 1) + "/" + pageCount);
		}
		if (type == CloudConstants.PRRVIEPHOTO_TYPE_SERVER) {
			downLoadImage(0);
		}
	}

	private void initListViews(String url) {
		if (listViews == null) {
			listViews = new ArrayList<View>();
		}
		// 构造ImageView对象
		ImageView img = new ImageView(this);
		img.setBackgroundColor(0xff000000);
		// img.setImageBitmap(bm);
		img.setLayoutParams(new LayoutParams(LayoutParams.MATCH_PARENT,
				LayoutParams.MATCH_PARENT));
		img.setScaleType(ScaleType.CENTER_CROP);
		listViews.add(img);// 添加view
	}

	private void initListViews(Bitmap bm) {
		if (listViews == null) {
			listViews = new ArrayList<View>();
		}
		// 构造ImageView对象
		ImageView img = new ImageView(this);
		img.setBackgroundColor(0xff000000);
		img.setImageBitmap(bm);
		img.setLayoutParams(new LayoutParams(LayoutParams.MATCH_PARENT,
				LayoutParams.MATCH_PARENT));
		img.setScaleType(ScaleType.CENTER_CROP);
		listViews.add(img);// 添加view
	}

	@Override
	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.title_lly_back:
		case R.id.bt_photo_ok:
			if (null != AddDataInfoActivity.instance) {
				AddDataInfoActivity.instance.updateAdapter();
			}
			finish();
			break;
		case R.id.bt_photo_del:
			if (listViews.size() == 1) {
				phtoPager.removeAllViews();
				listViews.clear();
				lstKeys.clear();
				if (null != AddDataInfoActivity.instance) {
					AddDataInfoActivity.instance.selectedPhotoMap.clear();
					AddDataInfoActivity.instance.updateAdapter();
				}
				finish();
			} else {
				if (null != AddDataInfoActivity.instance) {
					AddDataInfoActivity.instance.selectedPhotoMap
							.remove(lstKeys.get(pageIndex));
				}
				lstKeys.remove(pageIndex);
				pageCount--;
				phtoPager.removeAllViews();
				listViews.remove(pageIndex);
				adapter.setListViews(listViews);
				adapter.notifyDataSetChanged();
				tvPage.setText((pageIndex + 1) + "/" + pageCount);
			}
			break;
		}
	}

	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if (keyCode == KeyEvent.KEYCODE_BACK) {
			if (null != AddDataInfoActivity.instance) {
				AddDataInfoActivity.instance.updateAdapter();
			}
			finish();
		}
		return super.onKeyDown(keyCode, event);
	}

	@Override
	protected void onDestroy() {
		//清除公有静态变量
		if (null != ConfigableConst.bitmapByteList) {
			ConfigableConst.bitmapByteList = null;
		}
		if (null != ConfigableConst.imageEntityList) {
			ConfigableConst.imageEntityList = null;
		}
		super.onDestroy();
	}

	private void downLoadImage(final int index) {
		ImageEntity entity = ConfigableConst.imageEntityList.get(index);
		final ImageView view = (ImageView) listViews.get(index);
		// final ProgressDialog bar = new
		// ProgressDialog(PreviewPhotoActivity.this);
		// bar.show();
		pbLoding.setVisibility(View.VISIBLE);
		protocal.downloadImageView(entity.getUrl(), view,
				new BitmapLoadCallBack<ImageView>() {

					@Override
					public void onLoadCompleted(ImageView container,
							String uri, Bitmap bitmap,
							BitmapDisplayConfig config, BitmapLoadFrom from) {
						// TODO Auto-generated method stub
						// bar.cancel();
						pbLoding.setVisibility(View.GONE);
						loadImageCache.put(index, new SoftReference<Bitmap>(
								bitmap));
						view.setImageBitmap(bitmap);
						adapter.notifyDataSetChanged();
					}

					@Override
					public void onLoadFailed(ImageView container, String uri,
							Drawable drawable) {
						// TODO Auto-generated method stub
						// bar.cancel();
						pbLoding.setVisibility(View.GONE);
					}

				});
	}

	private OnPageChangeListener pageChangeListener = new OnPageChangeListener() {

		// 页面选择响应函数
		public void onPageSelected(int arg0) {
			if (type == CloudConstants.PRRVIEPHOTO_TYPE_SERVER) {
				Bitmap bitmap = null;
				ImageView view = (ImageView) listViews.get(arg0);
				if (loadImageCache.containsKey(arg0)) {
					SoftReference<Bitmap> reference = loadImageCache.get(arg0);
					bitmap = reference.get();
				}
				if (bitmap != null) {
					view.setImageBitmap(bitmap);
					adapter.notifyDataSetChanged();
				} else {
					downLoadImage(arg0);
				}
			}
			pageIndex = arg0;
			tvPage.setText((pageIndex + 1) + "/" + pageCount);
		}

		// 滑动中。。。
		public void onPageScrolled(int arg0, float arg1, int arg2) {

		}

		// 滑动状态改变
		public void onPageScrollStateChanged(int arg0) {

		}

	};

	private class MyPageAdapter extends PagerAdapter {

		private ArrayList<View> listViews;// content

		private int size;// 页数

		public MyPageAdapter(ArrayList<View> listViews) {// 构造函数
															// 初始化viewpager的时候给的一个页面
			this.listViews = listViews;
			size = listViews == null ? 0 : listViews.size();
		}

		public void setListViews(ArrayList<View> listViews) {// 自己写的一个方法用来添加数据
			this.listViews = listViews;
			size = listViews == null ? 0 : listViews.size();
		}

		public int getCount() {// 返回数量
			return size;
		}

		public int getItemPosition(Object object) {
			return POSITION_NONE;
		}

		public void destroyItem(View arg0, int arg1, Object arg2) {// 销毁view对象
			((ViewPager) arg0).removeView(listViews.get(arg1 % size));
		}

		public void finishUpdate(View arg0) {
		}

		public Object instantiateItem(View arg0, int arg1) {// 返回view对象
			try {
				((ViewPager) arg0).addView(listViews.get(arg1 % size), 0);

			} catch (Exception e) {
			}
			return listViews.get(arg1 % size);
		}

		public boolean isViewFromObject(View arg0, Object arg1) {
			return arg0 == arg1;
		}
	}

}
