/**
 */
package com.amap.app.cloud.activity;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.util.TypedValue;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup.LayoutParams;
import android.view.Window;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.amap.app.cloud.R;
import com.amap.app.cloud.constants.CloudConstants;
import com.amap.app.cloud.dao.DataBaseAdapter;
import com.amap.app.cloud.net.Protocal;
import com.amap.app.cloud.pojo.DatabaseItemEntity;
import com.amap.app.cloud.pojo.ImageEntity;
import com.amap.app.cloud.pojo.TableIdentifyStruct;
import com.amap.app.cloud.pojo.TableIdentifyStructResult;
import com.amap.app.cloud.util.ConfigableConst;
import com.amap.app.cloud.util.Util;
import com.lidroid.xutils.bitmap.BitmapDisplayConfig;
import com.lidroid.xutils.bitmap.callback.BitmapLoadCallBack;
import com.lidroid.xutils.bitmap.callback.BitmapLoadFrom;
import com.lidroid.xutils.exception.HttpException;
import com.lidroid.xutils.http.ResponseInfo;
import com.lidroid.xutils.http.callback.RequestCallBack;

/**
 * @Description: TODO
 * @Project: YuntuConsoleAPP
 * @Class: ShowDataInfoActivity
 * @date 2015年1月26日 下午3:04:39
 */
public class ShowDataInfoActivity extends Activity implements OnClickListener {

	private LinearLayout titleBack = null;

	private LinearLayout titleOption = null;
	private TextView titleDel = null;
	private TextView titleEdit = null;

	private ImageView ivAlertUpload = null;
	private ImageView ivDataImg = null; // 图片
	private RelativeLayout rlyDataImg = null;
	private TextView tvImgNum = null;
	private TextView tvName = null;
	private TextView tvAddr = null;

	private LinearLayout llyTimeDetail = null;
	private TextView tvCreateTimeTitle = null;
	private TextView tvCreateTime = null;
	private TextView mLine = null;
	private TextView tvUpdateTime = null;
	private ProgressBar pbLoadingImg = null;

	private ArrayList<ImageEntity> imageEntityList = new ArrayList<ImageEntity>();
	private ArrayList<byte[]> bitmapByteList = new ArrayList<byte[]>();
	private LinearLayout llyDetailProps = null;

	private DatabaseItemEntity dataEntity = null;
	private List<TableIdentifyStruct> propsList = new ArrayList<TableIdentifyStruct>();
	private Protocal mProtocal = null;
	private Map<String, String> propsMap = new HashMap<String, String>();
	private int index = -1;

	private int photoCount = 0;
	private boolean isLocal = false;
	
	

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_showdatainfo);
		mProtocal = ConfigableConst.getProtocalInstance(this.getApplicationContext());
		index = getIntent().getIntExtra("index", -1);
		if (index != -1) {
			dataEntity = MapTableDataActivity.instance.allDataList.get(index);
		}
	}

	private void showImage(boolean isLocal) {
		if (isLocal) {
			pbLoadingImg.setVisibility(View.GONE);
			bitmapByteList = dataEntity.getPhotoList();
			if (null != bitmapByteList) {
				photoCount = bitmapByteList.size();
			}
			tvImgNum.setText(photoCount + "张");

			if (photoCount > 0) {
				byte[] image = bitmapByteList.get(0);
				if (image != null) {
					Bitmap bitmap = Util.bytes2Bimap(image);
					ivDataImg.setImageBitmap(bitmap);
				}
			}
		} else {
			imageEntityList = dataEntity.getImage();
			if (null != imageEntityList) {
				photoCount = imageEntityList.size();
			}
			tvImgNum.setText(photoCount + "张");
			if (photoCount > 0) {
				pbLoadingImg.setVisibility(View.VISIBLE);
				Protocal imageProtocal = new Protocal(this, new ImageView(this));
				//只取第一张预览图片
				String url = imageEntityList.get(0).getPreUrl();
				imageProtocal.downloadImageView(url,
						new BitmapLoadCallBack<ImageView>() {
							@Override
							public void onLoadFailed(ImageView container,
									String uri, Drawable drawable) {
								pbLoadingImg.setVisibility(View.GONE);
								Util.showToast(getApplicationContext(),
										"图片加载失败!");
							}

							@Override
							public void onLoadCompleted(ImageView container,
									String uri, Bitmap bitmap,
									BitmapDisplayConfig config,
									BitmapLoadFrom from) {
								pbLoadingImg.setVisibility(View.GONE);
								ivDataImg.setImageBitmap(bitmap);
							}
						});
			}
		}
	}

	/**
	 * 根据提供的ImageEntity列表加载所有预览图片
	 * 
	 * @param imageEntityList
	 *            ImageEntity列表
	 */
	private void loadAllItemPreImage(ArrayList<ImageEntity> imageEntityList) {
		if (null == imageEntityList || imageEntityList.size() == 0) {
			return;
		}
		for (int i = 0; i < imageEntityList.size(); i++) {
			Protocal imageProtocal = new Protocal(this, new ImageView(this));
			String url = imageEntityList.get(i).getPreUrl();
			imageProtocal.downloadImageView(url,
					new BitmapLoadCallBack<ImageView>() {

						@Override
						public void onLoadFailed(ImageView container,
								String uri, Drawable drawable) {
							Util.showToast(getApplicationContext(), "加载失败!");
						}

						@Override
						public void onLoadCompleted(ImageView container,
								String uri, Bitmap bitmap,
								BitmapDisplayConfig config, BitmapLoadFrom from) {
							if (null == bitmapByteList) {
								bitmapByteList = new ArrayList<byte[]>();
							}
							byte[] bytedate = Util.getBitmapByte(bitmap);
							if (null != bytedate) {
								bitmapByteList.add(bytedate);
							}
						}
					});
		}
	}

	protected void onResume() {
		super.onResume();
		if (dataEntity.getCreateTime() == 0) {
			isLocal = true;
			try {
				DataBaseAdapter database = new DataBaseAdapter(this);
				database.open();
				dataEntity = database.fetchData(dataEntity.getId());
				database.close();
			} catch (Exception e) {
				e.printStackTrace();
			}
		} else {
			isLocal = false;
		}
		initView();
		
		tvName.setText(dataEntity.getName());
		tvAddr.setText(dataEntity.getAddress());
		showImage(isLocal);
		getTableStruct(ConfigableConst.tableID);
		setViewListener();
	}

	private void initView() {
		titleBack = (LinearLayout) findViewById(R.id.title_lly_back);
		titleOption = (LinearLayout) findViewById(R.id.title_lly_add);
		titleDel = (TextView) findViewById(R.id.title_tv_del);
		titleEdit = (TextView) findViewById(R.id.title_tv_edit);
		rlyDataImg = (RelativeLayout) findViewById(R.id.rly_dataImg);
		ivDataImg = (ImageView) findViewById(R.id.iv_dataImg);
		tvImgNum = (TextView) findViewById(R.id.tv_imgNum);
		tvName = (TextView) findViewById(R.id.tv_dataTitle);
		tvAddr = (TextView) findViewById(R.id.tv_dataAddr);
		ivAlertUpload = (ImageView) findViewById(R.id.iv_alertUpload);
		mLine = (TextView) findViewById(R.id.tv_line);
		llyDetailProps = (LinearLayout) findViewById(R.id.lly_detailProps);

		llyTimeDetail = (LinearLayout) findViewById(R.id.lly_timeDetail);
		tvCreateTimeTitle = (TextView) findViewById(R.id.tv_createTimeTitle);
		tvCreateTime = (TextView) findViewById(R.id.tv_createTime);
		tvUpdateTime = (TextView) findViewById(R.id.tv_updateTime);
		pbLoadingImg = (ProgressBar)findViewById(R.id.pb_loadingImg);
		if (dataEntity.getCreateTime() == 0) {
			setEditStyle(true);
		} else {
			setEditStyle(false);
		}
	}

	private void setEditStyle(boolean editable) {
		if (editable) {
			titleOption.setVisibility(View.VISIBLE);
			ivAlertUpload.setVisibility(View.VISIBLE);
			llyTimeDetail.setVisibility(View.GONE);
		} else {
			llyTimeDetail.setVisibility(View.VISIBLE);
			String timeFomat = "yyyy年MM月dd日 HH:mm:ss";
			tvCreateTime.setText(Util.formatDate(dataEntity.getCreateTime(),
					timeFomat));
			tvUpdateTime.setText(Util.formatDate(dataEntity.getUpdateTime(),
					timeFomat));

			titleOption.setVisibility(View.GONE);
			ivAlertUpload.setVisibility(View.GONE);
		}
	}

	private void setViewListener() {
		titleBack.setOnClickListener(this);
		titleDel.setOnClickListener(this);
		titleEdit.setOnClickListener(this);
		rlyDataImg.setOnClickListener(this);
	}

	/**
	 * 
	 * @param title
	 * @param data
	 * @param isShowLine
	 */
	private LinearLayout createPropsLayout(String key, String value,
			boolean isShowLine) {
		LinearLayout lly = new LinearLayout(this);
		lly.setOrientation(LinearLayout.VERTICAL);
		LayoutParams exampleTitleLp = tvCreateTimeTitle.getLayoutParams();
		LayoutParams exampleDataLp = tvCreateTime.getLayoutParams();

		TextView tvTitle = new TextView(this);
		TextView tvData = new TextView(this);
		tvTitle.setLayoutParams(exampleTitleLp);
		tvData.setLayoutParams(exampleDataLp);
		tvTitle.setTextSize(TypedValue.COMPLEX_UNIT_PX, getResources()
				.getDimension(R.dimen.textsize_list_item_titleText));
		tvData.setTextSize(TypedValue.COMPLEX_UNIT_PX, getResources()
				.getDimension(R.dimen.textsize_list_item_descText));
		tvTitle.setTextColor(getResources().getColor(
				R.color.textColor_list_item_titleText));
		tvData.setTextColor(getResources().getColor(
				R.color.textColor_list_item_descText));

		tvTitle.setText(key);
		tvData.setText(value);

		lly.addView(tvTitle);
		lly.addView(tvData);

		if (isShowLine) {
			TextView tvLine = new TextView(this);
			tvLine.setLayoutParams(mLine.getLayoutParams());
			tvLine.setBackgroundColor(getResources().getColor(
					R.color.backgroud_list_item_line));
			lly.addView(tvLine);
		}
		return lly;
	}

	@Override
	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.title_lly_back:
			finish();
			break;
		case R.id.title_tv_del:
			AlertDialog.Builder alert = new AlertDialog.Builder(this);
			alert.setTitle(getResources().getString(R.string.confirmDelData));
			alert.setPositiveButton("删除",
					new DialogInterface.OnClickListener() {

						@Override
						public void onClick(DialogInterface dialog, int which) {
							boolean result = deleteData(dataEntity);
							if (result) {
								Util.showToast(getApplicationContext(),
										getResources().getString(R.string.delDataSuccess));
								if (null != MapTableDataActivity.instance) {
									MapTableDataActivity.instance.onRefresh();
								}
								ShowDataInfoActivity.this.finish();
							} else {
								Util.showToast(getApplicationContext(),
										getResources().getString(R.string.delDataFail));
							}

						}
					});
			alert.setNegativeButton("取消",
					new DialogInterface.OnClickListener() {

						@Override
						public void onClick(DialogInterface dialog, int which) {
						}
					});
			alert.show();
			break;
		case R.id.title_tv_edit:
			Intent intent = new Intent(this, AddDataInfoActivity.class);
			intent.putExtra(ConfigableConst.EDITE_BOOLEAN, true);
			if (dataEntity != null) {
				intent.putExtra(ConfigableConst.DATA_ID, dataEntity.getId());
			}
			ConfigableConst.cacheActivity.add(this);
			startActivityForResult(intent, ConfigableConst.EDIT_DATA_REQUESET);
			break;
		case R.id.rly_dataImg:
			if (dataEntity == null) {
				break;
			}
			
			if (photoCount <= 0) {
				break;
			}

			Bundle bundle = new Bundle();
			if (isLocal) {
				ConfigableConst.bitmapByteList = bitmapByteList;
				bundle.putInt(CloudConstants.PRRVIEPHOTO_TYPE_KEY,
						CloudConstants.PRRVIEPHOTO_TYPE_LOCAL);
			} else {
				ConfigableConst.imageEntityList = imageEntityList;
				bundle.putInt(CloudConstants.PRRVIEPHOTO_TYPE_KEY,
						CloudConstants.PRRVIEPHOTO_TYPE_SERVER);
			}
			Intent priviewPhotointent = new Intent(ShowDataInfoActivity.this,
					PreviewPhotoActivity.class);
			priviewPhotointent.putExtras(bundle);
			startActivity(priviewPhotointent);
			break;
		}
	}

	private boolean deleteData(DatabaseItemEntity dataEntity) {
		if (dataEntity == null) {
			return false;
		}
		DataBaseAdapter dataAdapter = new DataBaseAdapter(this);
		dataAdapter.open();
		boolean dataresult = dataAdapter.deleteTableData(dataEntity.getId());
		boolean photoresult = dataAdapter.deletePhotoData(dataEntity.getId());
		return dataresult && photoresult;
	}

	private void getTableStruct(String tableId) {
		mProtocal.fetchTableStruct(tableId, ConfigableConst.sid,
				requestCallBack);
	}

	private RequestCallBack<String> requestCallBack = new RequestCallBack<String>() {
		@Override
		public void onSuccess(ResponseInfo<String> responseInfo) {
			TableIdentifyStructResult result = mProtocal.parseResult(
					responseInfo, TableIdentifyStructResult.class);
			if (result == null) {
				return;
			}
			int rc = result.getRc();

			if (rc != 1) {
				switch (rc) {
				case 0:
					Util.showToast(getApplicationContext(), "获取数据失败");
					break;
				case -1:
					Util.showToast(getApplicationContext(), "tableID不存在");
					break;
				default:
					Util.showToast(getApplicationContext(), "获取数据失败");
					break;
				}
				return;
			}
			propsList = result.getList();
			// 将结构存入map中
			for (int i = 0; i < propsList.size(); i++) {
				TableIdentifyStruct struct = propsList.get(i);
				if (null == struct.getName()
						|| struct.getName().trim().length() <= 0) {
					propsMap.put(struct.getKey(), struct.getKey());
				} else {
					propsMap.put(struct.getKey(), struct.getName());
				}
			}
			showPropsDetail();
		}

		@Override
		public void onFailure(HttpException error, String msg) {
			Util.showToast(getApplicationContext(), ConfigableConst.NET_ERROR);
		}
	};

	/**
	 * 显示自定义字段信息
	 */
	private void showPropsDetail() {
		// 自定义字段
		llyDetailProps.removeAllViews();
		JSONObject jsonObj = dataEntity.getProps();
		for (Iterator iter = jsonObj.keys(); iter.hasNext();) {
			String key = (String) iter.next();
			try {
				llyDetailProps.addView(createPropsLayout(propsMap.get(key),
						jsonObj.getString(key), true));
			} catch (JSONException e) {
				e.printStackTrace();
				continue;
			}
		}
	}
}
