package com.amap.app.cloud.util;

import java.lang.ref.SoftReference;
import java.util.HashMap;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Handler;
import android.text.TextUtils;
import android.widget.ImageView;

import com.amap.app.cloud.callback.ImageCallback;
import com.amap.app.cloud.constants.CloudConstants;

public class BitmapCache {

	public Handler h = new Handler();
	public final String TAG = getClass().getSimpleName();
	private HashMap<String, SoftReference<Bitmap>> imageCache = new HashMap<String, SoftReference<Bitmap>>();

	public void put(String path, Bitmap bmp) {
		if (!TextUtils.isEmpty(path) && bmp != null) {
			imageCache.put(path, new SoftReference<Bitmap>(bmp));
		}
	}

	public void displayBmp(final ImageView iv, final String thumbPath,
			final String sourcePath, final ImageCallback callback) {
		if (TextUtils.isEmpty(thumbPath) && TextUtils.isEmpty(sourcePath)) {
			return;
		}

		final String path;
		final boolean isThumbPath;
		if (!TextUtils.isEmpty(thumbPath)) {
			path = thumbPath;
			isThumbPath = true;
		} else if (!TextUtils.isEmpty(sourcePath)) {
			path = sourcePath;
			isThumbPath = false;
		} else {
			return;
		}

		if (imageCache.containsKey(path)) {
			SoftReference<Bitmap> reference = imageCache.get(path);
			Bitmap bmp = reference.get();
			if (bmp != null) {
				if (callback != null) {
					callback.onImageLoaded(iv, bmp, sourcePath);
				}
				iv.setImageBitmap(bmp);
				return;
			}
		}
		iv.setImageBitmap(null);

		new Thread() {
			Bitmap bitmap;

			public void run() {

				try {
					if (isThumbPath) {
						bitmap = BitmapFactory.decodeFile(thumbPath);
						bitmap = ImageUtil.rotaingImageView(thumbPath);
						if (bitmap == null) {
							bitmap = ImageUtil.revisionImageSize(sourcePath, CloudConstants.MAXPHOTOPIXEL);
						}
					} else {
						bitmap = ImageUtil.revisionImageSize(sourcePath, CloudConstants.MAXPHOTOPIXEL);
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
				// if (thumb == null) {
				// thumb = TestPicActivity.bimap;
				// }
				put(path, bitmap);

				if (callback != null) {
					h.post(new Runnable() {
						@Override
						public void run() {
							callback.onImageLoaded(iv, bitmap, sourcePath);
						}
					});
				}
			}
		}.start();

	}
}
