package com.amap.app.cloud.util;

public class ServerError {
	public final static String SUCCESS = "正常";
	public final static String SERVER_MAINTAIN = "服务器维护中,请稍后重试";
	public final static String UNKNOW_ERROR = "未知错误";
	public final static String UNKNOW_SID = "sid无效或已过期";
	public final static String INVALIDATE_VERSION = "无效的协议版本v";
	public final static String INVALIDATE_CID = "无效的cid";
	public final static String INVALIDATE_PARAMS = "参数缺失或格式非法";
	public final static String NO_PERMISSION = "权限不足";
	public final static String ACCOUNT_FROZEN = "帐号已冻结";
	public final static String CACHE_ERROT = "缓存错误";
	public final static String DATABASE_REEOR = "数据库错误";
	public final static String MESSAGEQUEEN_ERROR = "消息队列错误";
	public final static String HTTP_FAILURE_APISERVER = "外部HTTP调用失败：API-Server";
	public final static String HTTP_FAILURE_PERMISSION = "外部HTTP调用失败：权限系统";
	public final static String HTTP_FAILURE_SEARCH_ENGINE = "外部HTTP调用失败：搜索引擎";
	public final static String HTTP_FAILURE_SENSITIVE = "外部HTTP调用失败：敏感词服务";
	public final static String OSS_ERROR = "OSS错误";

	private final static String ERR_RELOGIN = "用户名或密码错误，请重新登录";
	private final static String ERR_INVALID_ACCOUNT = "账号无效";
	private final static String ERR_CONNECT = "请求失败，请稍后重试";

	public static String getMessage(int error) {
		switch (error) {
		case 1:
			return SUCCESS;
		case 101:
			return SERVER_MAINTAIN;
		case -11:
		case -22:
			return ERR_RELOGIN;
		case -41:
		case -42:
			return ERR_INVALID_ACCOUNT;
		case -101:
			return CACHE_ERROT;
		case 0:
		case -21:
		case -31:
		case -201:
		case -301:
		case -401:
		case -402:
		case -403:
		case -404:
		case -501:
			return ERR_CONNECT;
		default:
			return "";
		}
	}
}
